/*
 * XModeFactory.java - Factory to create xmode instances from Readers
 * Copyright (C) 1999 mike dillon
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import com.microstar.xml.*;

import java.io.*;

import org.gjt.sp.jedit.*;

import org.gjt.sp.util.Log;

public class XModeFactory
{
	// public members
	public static xmode createXMode(Reader grammar, String fileName)
	{
		XModeHandler xmh = new XModeHandler();
		XmlParser parser = new XmlParser();
		parser.setHandler(xmh);
		try
		{
			parser.parse(null, null, grammar);
		}
		catch (Exception e)
		{
			if (e instanceof XmlException)
			{
				XmlException xe = (XmlException) e;
				int line = xe.getLine();
				int col = xe.getColumn();
				String message = xe.getMessage();

				XModePlugin.addError(fileName, line, message);
			}
			else
			{
				Log.log(Log.ERROR, XModePlugin.class, e);
			}
		}

		return xmh.getXMode();
	}

	// private members
	private XModeFactory() {}
}
